/******************************************************************************/
/***               Generated by IBExpert 11.09.2018 10:37:41                ***/
/******************************************************************************/

/******************************************************************************/
/***      Following SET SQL DIALECT is just for the Database Comparer       ***/
/******************************************************************************/
SET SQL DIALECT 3;



/******************************************************************************/
/***                                 Tables                                 ***/
/******************************************************************************/



CREATE TABLE DP_NAMELINKS (
    D$UUID         DM_UUID NOT NULL /* DM_UUID = CHAR(36) NOT NULL */,
    POSITION_UUID  DM_UUID /* DM_UUID = CHAR(36) NOT NULL */,
    NAME_KEY       DM_TEXT /* DM_TEXT = VARCHAR(250) */,
    D$SRVUPDDT     DM_DATETIME /* DM_DATETIME = TIMESTAMP */,
    A1             DM_TEXT /* DM_TEXT = VARCHAR(250) */,
    A2             DM_TEXT /* DM_TEXT = VARCHAR(250) */,
    A3             DM_TEXT /* DM_TEXT = VARCHAR(250) */,
    A4             DM_TEXT /* DM_TEXT = VARCHAR(250) */,
    X1             DM_TEXT /* DM_TEXT = VARCHAR(250) */,
    X2             DM_TEXT /* DM_TEXT = VARCHAR(250) */
);




/******************************************************************************/
/***                              Primary keys                              ***/
/******************************************************************************/

ALTER TABLE DP_NAMELINKS ADD CONSTRAINT PK_DP_NAMELINKS_1 PRIMARY KEY (D$UUID);


/******************************************************************************/
/***                                Indices                                 ***/
/******************************************************************************/

CREATE INDEX DP_NAMELINKS_IDX1 ON DP_NAMELINKS (POSITION_UUID);
CREATE INDEX DP_NAMELINKS_IDX2 ON DP_NAMELINKS (NAME_KEY);


/******************************************************************************/
/***                                Triggers                                ***/
/******************************************************************************/



SET TERM ^ ;



/******************************************************************************/
/***                          Triggers for tables                           ***/
/******************************************************************************/



/* Trigger: DP_NAMELINKS_AD_DISTR */
CREATE OR ALTER TRIGGER DP_NAMELINKS_AD_DISTR FOR DP_NAMELINKS
ACTIVE AFTER DELETE POSITION 0
AS
begin
  update or insert into g$distribute (TABLENAME,UUID,SOPER,FROM_PROFILE_ID) values ('DP_NAMELINKS',old.d$uuid,2,null)
  matching (TABLENAME,UUID);
end
^


/* Trigger: DP_NAMELINKS_BI0 */
CREATE OR ALTER TRIGGER DP_NAMELINKS_BI0 FOR DP_NAMELINKS
ACTIVE BEFORE INSERT POSITION 0
AS
begin
  if (new.d$uuid is null) then
    new.d$uuid=UUID_TO_CHAR(GEN_UUID());
  if (new.d$srvupddt is null) then
    new.d$srvupddt=current_timestamp;
  new.name_key=upper(new.name_key);
end
^


/* Trigger: DP_NAMELINKS_BI_DISTR */
CREATE OR ALTER TRIGGER DP_NAMELINKS_BI_DISTR FOR DP_NAMELINKS
ACTIVE BEFORE INSERT POSITION 0
AS
begin
  if (new.d$uuid is null) then
  begin
    new.d$uuid=UUID_TO_CHAR(GEN_UUID());
    new.d$srvupddt='2000-01-01';
    update or insert into g$distribute (TABLENAME,UUID,SOPER,FROM_PROFILE_ID) values ('DP_NAMELINKS',new.d$uuid,0,null) matching (TABLENAME,UUID);
  end
end
^


/* Trigger: DP_NAMELINKS_BU0 */
CREATE OR ALTER TRIGGER DP_NAMELINKS_BU0 FOR DP_NAMELINKS
ACTIVE BEFORE UPDATE POSITION 0
AS
begin
  new.name_key=upper(new.name_key);
end
^


/* Trigger: DP_NAMELINKS_BU_DISTR */
CREATE OR ALTER TRIGGER DP_NAMELINKS_BU_DISTR FOR DP_NAMELINKS
ACTIVE BEFORE UPDATE POSITION 0
AS
begin
  if (new.D$SRVUPDDT=old.D$SRVUPDDT) then
  begin
     update or insert into g$distribute (TABLENAME,UUID,SOPER,FROM_PROFILE_ID) values ('DP_NAMELINKS',new.d$uuid,1,null)
     matching (TABLENAME,UUID);
  end

end
^

SET TERM ; ^



/******************************************************************************/
/***                              Descriptions                              ***/
/******************************************************************************/

COMMENT ON TABLE DP_NAMELINKS IS 
'NAME_KEY -  
A1..A4 -  ,  ,  ,      -      
X1..X2 -    -          -  ';



/******************************************************************************/
/***                               Privileges                               ***/
/******************************************************************************/


INSERT INTO DP_NAMELINKS (D$UUID, POSITION_UUID, NAME_KEY, D$SRVUPDDT, A1, A2, A3, A4, X1, X2)
                  VALUES ('116F37FD-66E7-421F-8AE0-40CB671FB1EA', '47EDE5E7-99A6-40F6-8803-4126969C24CC', '', '2018-09-07 16:30:14', ' ', NULL, NULL, NULL, NULL, NULL);
INSERT INTO DP_NAMELINKS (D$UUID, POSITION_UUID, NAME_KEY, D$SRVUPDDT, A1, A2, A3, A4, X1, X2)
                  VALUES ('B853589A-A09D-400C-BFC0-B8F86914FFF1', '40ECB931-DF5F-43A1-965E-44A8977DC52F', '', '2018-09-10 11:53:28', '', '', NULL, NULL, NULL, NULL);
INSERT INTO DP_NAMELINKS (D$UUID, POSITION_UUID, NAME_KEY, D$SRVUPDDT, A1, A2, A3, A4, X1, X2)
                  VALUES ('5670478A-065E-4830-A58F-C835D103FFBC', '2454B4BB-EDAA-45B4-BF2A-A795B64097E8', '', '2018-09-11 09:18:27', '', '', NULL, NULL, NULL, NULL);
INSERT INTO DP_NAMELINKS (D$UUID, POSITION_UUID, NAME_KEY, D$SRVUPDDT, A1, A2, A3, A4, X1, X2)
                  VALUES ('3AB84AFA-AE76-4942-8E5E-EBB26B358783', 'CE4EA2FF-C35C-4ACD-B6FC-7538D0A68328', '', '2018-09-07 17:21:40', '', '10', NULL, NULL, NULL, NULL);
INSERT INTO DP_NAMELINKS (D$UUID, POSITION_UUID, NAME_KEY, D$SRVUPDDT, A1, A2, A3, A4, X1, X2)
                  VALUES ('44B3D465-BA17-448E-9E13-E17DA12D8B44', '887F354A-B09A-485E-8A1D-A3BA684702C5', '', '2018-09-10 11:59:38', '', NULL, NULL, NULL, NULL, NULL);
INSERT INTO DP_NAMELINKS (D$UUID, POSITION_UUID, NAME_KEY, D$SRVUPDDT, A1, A2, A3, A4, X1, X2)
                  VALUES ('7E5293D7-80CA-472C-8C95-BACEBABD5688', '877F8450-F60C-4B60-A767-F29BA143FB6D', '', '2018-09-10 08:39:07', '', '', NULL, NULL, NULL, NULL);
INSERT INTO DP_NAMELINKS (D$UUID, POSITION_UUID, NAME_KEY, D$SRVUPDDT, A1, A2, A3, A4, X1, X2)
                  VALUES ('D2D9977B-8931-40AD-9D0B-FAC7ECC532D8', '6A92F1EB-8A5D-4898-9C3B-70511B96DBF5', '', '2018-09-11 09:20:53', '', NULL, NULL, NULL, NULL, NULL);
INSERT INTO DP_NAMELINKS (D$UUID, POSITION_UUID, NAME_KEY, D$SRVUPDDT, A1, A2, A3, A4, X1, X2)
                  VALUES ('C52DEB7D-FCFF-4568-9CB9-21CA7FCE4F4F', '02D76E9C-9CCF-4A9E-B15B-8C2FDDC7F78E', '', '2018-09-10 12:00:19', '', NULL, NULL, NULL, NULL, NULL);

COMMIT WORK;
